<?php
/**
 * Created by PhpStorm.
 * User: gets
 * Date: 4/4/2019
 * Time: 3:24 PM
 */

namespace App\Http\Controllers;

use App\Classes\MResponse;
use App\Http\Request\Application\CreateDefaultApplicationRequest;

class ApplicationController extends BaseController
{
    public function createDefault(CreateDefaultApplicationRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;

        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userid') . '/applications'; 

        try {
            $response = $this->masheryClient()->request('POST', $url, [
                'json' => [
                    'name' => $request->get('marketplace-name') . '-DefaultApp',
                    'username' => $request->get('username'),
                    'description' => '',
                    'type' => '',
                    'commercial' => false,
                    'ads' => false,
                    'adsSystem' => '',
                    'usageModel' => '',
                    'tags' => '',
                    'notes' => '',
                    'howDidYouHear' => '',
                    'preferredProtocol' => '',
                    'preferredOutput' => '',
                    'externalId' => '',
                    'uri' => '',
                    'oauthRedirectUri' => ''
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function createApp(CreateDefaultApplicationRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userid') . '/applications'; 

        try {
            $response = $this->masheryClient()->request('POST', $url, [
                'json' => [
                    'name' => $request->get('marketplace-name') . '-WebApp',
                    'username' => $request->get('username'),
                    'description' => '',
                    'type' => '',
                    'commercial' => false,
                    'ads' => false,
                    'adsSystem' => '',
                    'usageModel' => '',
                    'tags' => '',
                    'notes' => '',
                    'howDidYouHear' => '',
                    'preferredProtocol' => '',
                    'preferredOutput' => '',
                    'externalId' => '',
                    'uri' => '',
                    'oauthRedirectUri' => ''
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }
}
